                 /*ͻ
                  C Easy sample4.c: Browse Check Edit  
                 */

#include "\ceasy\ceasy1.h"       // required C Easy header files
#include "\ceasy\ceasy2.h"

#define width   50               // width of screen edit window
#define height  10               // height of screen edit window
#define line     8               // top line of screen edit window
#define column  15               // left column of screen edit window
#define windows 12               // number of edit windows allocated in memory

char *browsearea;                // pointer to browse area in memory

#define CHECK_MARK 251

main()
{
 FILE *fptr;
 unsigned char *i;
 int x, outline, outcolumn;

 start_program();                    // required
 initialize();                       // screen colors & memory initialization

 if ( (fptr = xopen("sample5.txt","r"))!=NULL)
  {
   fclose(fptr);
   read_text ( "sample5.txt",        // reads text file if it exists
                browsearea,          // points to browse area in memory
                width,               // text line & window width
                windows*height );    // maximum number of lines to be read
  }

//-------------- Only line changed from sample4.c ------------------------
 browse_check_edit (
//------------------------------------------------------------------------
          browsearea+height*width,   // points to browse area in memory
          (windows-1)*height*width,  // size of browse are in memory
          width,                     // width of screen window
          height,                    // height of screen window
          line,                      // top line of screen window
          column );                  // left column of screen window

 write_text ( "sample5.txt"    ,     // writes browse area to text file
             browsearea        ,     // points to browse area in memory
             width             ,     // text line & window width
             windows*height   );     // maximum number of lines to be read

 clear_screen( BKGND_BLUE, FGND_YELLOW );
 outline = 3;                        // starting display line
 cursor( outline, 5 );               // position cursor
 set_color ( BKGND_BLUE );           // set background color
 set_color ( FGND_MAGENTA );         // set foregound color

 see(" SELECTED ITEMS: ");           // display title
 outline+=2;                         // advance cursor by two lines

 for (                               // scan browse area for checked items
      i = browsearea+height*width, x = ( windows-1)*height; x; i+=width, x-- )
  {
   if( *i == CHECK_MARK )
    {
     cursor ( outline++, 8 );        // position cursor on next line
     see_( i, width );               // display selected (checked) line
    }
  }

 BKGND_FORM = BKGND_BLUE;            // background color for message
 display_message(" The above items were selected ", NULL );

 stop_program(0);                    // required
 return(0);                          // to inhibit warning message
}

int initialize()
{
 clear_screen ( BKGND_CYAN,          // clear screen to cyan background
                FGND_YELLOW );
 BKGND_WINDOW = BKGND_GRAY   ;       // background color for window
 FGND_WINDOW  = FGND_RED     ;       // foreground color for window
 FRAME_TYPE   = DOUBLE_LINE  ;       // window frame double line (not single)
 BKGND_FRAME  = BKGND_GRAY   ;       // backgound color for window frame
 FGND_FRAME   = FGND_RED     ;       // foregound color for window frame
 SHADOW_TYPE  = RIGHT_SHADOW ;       // frame shadow on right (not left)
 BKGND_SHADOW = BKGND_BLACK  ;       // frame shadow color
 BKGND_TIME   = BKGND_CYAN   ;       // background color for time display
 BKGND_BAR    = BKGND_BLUE   ;
 FGND_BAR     = FGND_YELLOW  ;

 if (( browsearea = Malloc( windows*height*width )) == NULL )
  {
   display_error ( "Cannot malloc memory", NULL );
   stop_program (-1);
  }

 erase ( browsearea,                 // pointer to browse area
         windows*height*width );     // size of browse area

 enable_time( 'C', SL, 66 );         // enable mouse and display time
 return (0);
}
